#oneChannelGUI miRNAbowtieRun executes bowtie and convert a sam in a bam file  miRNAs-seq
#oneChannelGUI mRNAbowtieRun executes bowtie and convert a sam in a bam file  mRNAs-seq
#                            the resulting bam files contains only the mapped reads
#oneChannelGUI adaptorTrimm run a perl script that remove 5 ad 3 prime end adaptors from illumina reads
#oneChannelGUI NGSreformat uses perl scripts to reformat the output of shrimp  v2 in a form suitable to be uploaded on oneChannelGUI
#oneChannelGUI makeSam function is used to create a samtools for each bam generated by tophat
#oneChannelGUI dexCounts uses the dex python script to generate a count object. Uses the target generated by makeSam
#oneChannelGUI dexExons
#oneChannelGUI desGenes
#oneChannelGUI topTable.exons filtering and saving a topTable for exon-level analysis with dexseq
#oneChannelGUI topTable.genes filtering and saving a topTable for gene-level analysis with deseq
#openPdf, closePdf useful to open connection to pdf under linux system
################################################################################
"miRNAbowtieRun" <-function(){
      Try(ptm <- proc.time())
      Try(tkfocus(.affylmGUIglobals$ttMain))
      Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
      Try(etcDir  <- paste(.path.package("oneChannelGUI", quiet = FALSE), "/etc", sep=""))
      Try(localdata <- paste(etcDir, "/localData.txt", sep=""))
      Try(myinfo <- read.table(localdata, sep="\t", header=F, as.is=T))
 #     Try(SetWD())
      Try(myWD <- getwd())
      if(is.na(myinfo[which(myinfo[,1]== "bowtieDirLocation"),2])){
           Try(tkmessageBox(title="Bowtie",message="Bowtie cannot be found please go to the General tool menu and use the function\nInstall Bowtie and Picard tools\nto install Bowtie.",icon="error",type="ok"))
           Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
           Try(tkfocus(.affylmGUIglobals$ttMain))
           Try(return())
      }
      Try(setwd(myinfo[which(myinfo[,1]== "bowtieDirLocation"),2]))
      Try(data.in.dir <- dir())
      Try(data.in.dir <- data.in.dir[grep('_nc.ebwt$',data.in.dir)])
      Try(data.in.dir <- strsplit(data.in.dir, "\\."))
      Try(data.in.dir <- unique(sapply(data.in.dir, function(x) x[1])))
      Try(refnames <- paste(data.in.dir, seq(1, length(data.in.dir)), sep=" = ", collapse=", "))
      ##selecting the ref set for mapping
     #select ref genome 
     Try(ttGetGenomes <- tktoplevel(.affylmGUIglobals$ttMain))
     Try(tkwm.deiconify(ttGetGenomes))
     Try(tkgrab.set(ttGetGenomes))
     Try(tkfocus(ttGetGenomes))
     Try(tkwm.title(ttGetGenomes,"Which miRNA precursors set do you want to use as reference?"))
     Try(tkgrid(tklabel(ttGetGenomes,text="    ")))
     Try(ttGetGenomesTcl <- tclVar("hg19"))
     Try(rbIQR.hs <- tkradiobutton(ttGetGenomes,text="Human miRNA precursors", variable=ttGetGenomesTcl,value="hs_nc",font=.affylmGUIglobals$affylmGUIfont2))
     Try(rbIQR.mm<-tkradiobutton(ttGetGenomes,text="Mouse miRNA precursors", variable=ttGetGenomesTcl,value="mm_nc",font=.affylmGUIglobals$affylmGUIfont2))
     Try(rbIQR.rn<-tkradiobutton(ttGetGenomes,text="Rat miRNA precursors", variable=ttGetGenomesTcl,value="rn_nc",font=.affylmGUIglobals$affylmGUIfont2))
     Try(rbIQR.bo<-tkradiobutton(ttGetGenomes,text="Bovine miRNA precursors", variable=ttGetGenomesTcl,value="bo_nc",font=.affylmGUIglobals$affylmGUIfont2))
     
     Try(tkgrid(tklabel(ttGetGenomes,text="    "),rbIQR.hs))
     Try(tkgrid(tklabel(ttGetGenomes,text="    "),rbIQR.mm))
     Try(tkgrid(tklabel(ttGetGenomes,text="    "),rbIQR.rn))
     Try(tkgrid(tklabel(ttGetGenomes,text="    "),rbIQR.bo))

     Try(tkgrid.configure(rbIQR.hs,rbIQR.mm,rbIQR.rn, rbIQR.bo, columnspan=2,sticky="w"))
     Try(tkgrid(tklabel(ttGetGenomes,text="    "),tklabel(ttGetGenomes,text="    ")))
     Try(ReturnVal1 <- "")
     Try(onCancel <- function() {Try(ReturnVal1 <<- "");Try(tkgrab.release(ttGetGenomes));Try(tkdestroy(ttGetGenomes));Try(tkfocus(.affylmGUIglobals$ttMain))})
     Try(onOK <- function() {Try(ReturnVal1 <<- tclvalue(ttGetGenomesTcl));Try(tkgrab.release(ttGetGenomes));Try(tkdestroy(ttGetGenomes));Try(tkfocus(.affylmGUIglobals$ttMain))})
     Try(OK.but     <- tkbutton(ttGetGenomes,text="OK",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
     Try(Cancel.but <- tkbutton(ttGetGenomes,text="Cancel",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))

     Try(tkgrid(tklabel(ttGetGenomes,text="    "),OK.but,Cancel.but, tklabel(ttGetGenomes,text="    ")))
     Try(tkgrid.configure(OK.but,sticky="e"))
     Try(tkgrid.configure(Cancel.but,sticky="w"))
     Try(tkgrid(tklabel(ttGetGenomes,text="    ")))

     Try(tkbind(ttGetGenomes,"<Destroy>",function() {ReturnVal1 <- "";Try(tkgrab.release(ttGetGenomes));Try(tkfocus(.affylmGUIglobals$ttMain));}))
     Try(tkbind(OK.but, "<Return>",onOK))
     Try(tkbind(Cancel.but, "<Return>",onCancel))      
     Try(tkwait.window(ttGetGenomes))
     Try(tkfocus(.affylmGUIglobals$ttMain))
     Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
     Try(setwd(myWD))  #back again in the working dir
     
      #opening target for primary mapping
    	Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
      Try(ttExonandTargets<-tktoplevel(.affylmGUIglobals$ttMain))
	    Try(tkwm.deiconify(ttExonandTargets))
	    Try(tkgrab.set(ttExonandTargets))
	    Try(tkfocus(ttExonandTargets))
	    Try(tkwm.title(ttExonandTargets,"Targets file"))
      Try(tkgrid(tklabel(ttExonandTargets,text="    ")))

	    OpenTargetsFileAndSetCursor <- function()
	   {
		   	Try(tkconfigure(ttExonandTargets,cursor="watch"))
			  Try(tkfocus(ttExonandTargets))
			  Try(OpenTargetsFile())
			  Try(tkconfigure(ttExonandTargets,cursor="arrow"))
			  Try(tkfocus(ttExonandTargets))
	   } 

	   Try(OpenTargetsFile.but <- tkbutton(ttExonandTargets, text="Select Targets File",command=OpenTargetsFile,font=.affylmGUIglobals$affylmGUIfont2))

	   Try(tclvalue(.affylmGUIglobals$TargetsfileName) <- fixSeps(tclvalue(.affylmGUIglobals$TargetsfileName)))
	   Try(TargetsfileBoxTitleLabel <- tklabel(ttExonandTargets,text=as.character(tclvalue(.affylmGUIglobals$TargetsfileBoxTitle)),font=.affylmGUIglobals$affylmGUIfont2))
	   Try(TargetsfileNameLabel <- tklabel(ttExonandTargets,text=as.character(tclvalue(.affylmGUIglobals$TargetsfileName)),background="white",font=.affylmGUIglobals$affylmGUIfont2))
	   Try(tkconfigure(TargetsfileBoxTitleLabel, textvariable=.affylmGUIglobals$TargetsfileBoxTitle))
	   Try(tkconfigure(TargetsfileNameLabel, textvariable=.affylmGUIglobals$TargetsfileName))

	   Try(tkgrid(tklabel(ttExonandTargets,text="    ")))
	   Try(tkgrid(TargetsfileBoxTitleLabel,columnspan=4))
	   Try(tkgrid(TargetsfileNameLabel,columnspan=4))

	   Try(tkgrid(tklabel(ttExonandTargets,text="    ")))

	   Try(tkgrid(tklabel(ttExonandTargets,text="    "),OpenTargetsFile.but))
	   Try(tkgrid.configure(OpenTargetsFile.but,columnspan=2))
	   Try(Abort <- 1)
	   onOK <- function()
	  {
			  Try(Targets <- get("Targets",envir=affylmGUIenvironment))
			  Try(if(length(Targets)==0)
			  {
				   Try(tkmessageBox(title="NGS Targets File",message=paste("Either you did not specify a valid NGS Targets File",
					   "or an error occurred while reading in the Targets file.	It should be in tab-delimited text format and it should include the column headings \"FileName\", and \"Target\".",icon="error")))
				   onCancel()
			  })
			  Try(tkgrab.release(ttExonandTargets));
			  Try(tkdestroy(ttExonandTargets));
			  Try(tkfocus(.affylmGUIglobals$ttMain))
			  Try(Abort <<- 0)
	  }
	  onCancel <- function() {Try(tkgrab.release(ttExonandTargets));Try(tkdestroy(ttExonandTargets));Try(tkfocus(.affylmGUIglobals$ttMain));Try(Abort<<-1)}
	  Try(OK.but <-tkbutton(ttExonandTargets,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
	  Try(Cancel.but <-tkbutton(ttExonandTargets,text=" Cancel ",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))
	  Try(tkgrid(tklabel(ttExonandTargets,text="    ")))
	  Try(tkgrid(tklabel(ttExonandTargets,text="    "),OK.but,Cancel.but))
	  Try(tkgrid(tklabel(ttExonandTargets,text="       ")))
	  Try(tkfocus(ttExonandTargets))
	  Try(tkbind(ttExonandTargets, "<Destroy>", function() {Try(tkgrab.release(ttExonandTargets));Try(tkfocus(.affylmGUIglobals$ttMain));}))
	  Try(tkwait.window(ttExonandTargets))
      
	  if(Abort==1)
				return(0)
	  Try(tkfocus(.affylmGUIglobals$ttMain))
	  Try(Targets <- get("Targets",affylmGUIenvironment))
	  Try(Targets.sam <- Targets)
	  #make a bam file
    Try(javaDir <- get("javaDir",envir=affylmGUIenvironment))
    if(is.na(javaDir)){javaDir <- ""}
    if(javaDir != ""){
          Try(picardLoc <- paste('"',javaDir,'"', "/bin/java -jar ",myinfo[which(myinfo[,1]== "bowtieDirLocation"),2], "/SamFormatConverter.jar", sep=""))

    }else{
          Try(picardLoc <- paste("java -jar ",myinfo[which(myinfo[,1]== "bowtieDirLocation"),2], "/SamFormatConverter.jar", sep=""))
    }
    Try(refGenome <- paste(myinfo[which(myinfo[,1]== "bowtieDirLocation"),2],ReturnVal1,sep="/"))
    #defining bowtie params#####################################################
    Try(botwieParams<-tktoplevel(.affylmGUIglobals$ttMain))
    Try(tkwm.deiconify(botwieParams))
    Try(tkgrab.set(botwieParams))
    Try(tkfocus(botwieParams))
    Try(tkwm.title(botwieParams,"Bowtie parameters"))
    Try(tkgrid(tklabel(botwieParams,text="    ")))

    Try(frame1 <- tkframe(botwieParams,relief="groove",borderwidth=2))
    Try(HowManyQuestion1 <- tklabel(frame1,text="Number of allowed mismatches",font=.affylmGUIglobals$affylmGUIfont2))
    Try(tkgrid(HowManyQuestion1))
    Try(tkgrid.configure(HowManyQuestion1,columnspan=2,sticky="w"))
    Try(thresholdTcl <- tclVar("1"))
    Try(I0.but  <- tkradiobutton(frame1,text="1",variable=thresholdTcl,value="1",font=.affylmGUIglobals$affylmGUIfont2))
    Try(I1.but  <- tkradiobutton(frame1,text="2",variable=thresholdTcl,value="2",font=.affylmGUIglobals$affylmGUIfont2))
    Try(I2.but  <- tkradiobutton(frame1,text="3",variable=thresholdTcl,value="3",font=.affylmGUIglobals$affylmGUIfont2))
    Try(tkgrid(I0.but,sticky="w"))
    Try(tkgrid(I1.but,sticky="w"))
    Try(tkgrid(I2.but,sticky="w"))

    Try(tkgrid.configure(HowManyQuestion1,I0.but,I1.but,I2.but,sticky="w"))

    Try(frame2 <- tkframe(botwieParams,relief="groove",borderwidth=2))
    Try(fractionLabel <- tklabel(frame2,text="Input data type",font=.affylmGUIglobals$affylmGUIfont2))
    Try(tkgrid(fractionLabel,sticky="w"))
    Try(tkgrid.configure(fractionLabel,sticky="w"))
    Try(fractionTcl <- tclVar("-q"))
    Try(F1.but <- tkradiobutton(frame2,text="FASTQ",variable=fractionTcl,value="-q",font=.affylmGUIglobals$affylmGUIfont2))

    Try(tkgrid(F1.but,sticky="w"))
    Try(tkgrid.configure(fractionLabel,F1.but,sticky="w"))

    Try(onOK <- function()
    {
                            bowtieVal1 <- tclvalue(thresholdTcl)
                            bowtieVal2 <- tclvalue(fractionTcl)
                            Try(bowtieVal <<- paste(bowtieVal1, bowtieVal2, sep=";"))
                            Try(tkgrab.release(botwieParams))
                            Try(tkdestroy(botwieParams))
                            Try(tkfocus(.affylmGUIglobals$ttMain))
    })

    Try(frame3 <- tkframe(botwieParams,borderwidth=2))
    Try(onCancel <- function() {Try(bowtieVal <<- ""); Try(tkgrab.release(botwieParams));Try(tkdestroy(botwieParams));Try(tkfocus(.affylmGUIglobals$ttMain))})
    Try(OK.but <-tkbutton(frame3,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
    Try(Cancel.but <-tkbutton(frame3,text=" Cancel ",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))

    Try(tkgrid(tklabel(frame3,text="    "),OK.but,Cancel.but,tklabel(frame3,text="    ")))

    Try(tkgrid(tklabel(botwieParams,text="    "),frame1,frame2,tklabel(botwieParams,text="  ")))
    Try(tkgrid(tklabel(botwieParams,text="    ")))
    Try(tkgrid(tklabel(botwieParams,text="    "),frame3,tklabel(botwieParams,text="  ")))
    Try(tkgrid(tklabel(botwieParams,text="    ")))
    Try(tkgrid.configure(frame1,frame3,sticky="w"))

    Try(tkfocus(botwieParams))
    Try(tkbind(botwieParams, "<Destroy>", function() {Try(tkgrab.release(botwieParams));Try(tkfocus(.affylmGUIglobals$ttMain));}))
                       Try(tkwait.window(botwieParams))
    Try(if(bowtieVal==""){return()} )
    Try(tmp <-strsplit(bowtieVal, ";"))
    Try(mismatch <- as.numeric(tmp[[1]][1]))
    Try(data.type <- tmp[[1]][2])
    ############################################################################
    for (i in 1: dim(Targets)[1]){
	  Try(outputSam <- paste(getwd(),paste(Targets$FileName[i],".sam", sep=""),sep="/"))
	  Try(inputData <- paste(getwd(),Targets$FileName[i],sep="/"))
      Try(cat("Processing: ", Targets$FileName[i],"\n"))
      Try(Targets.sam$FileName[i]<-paste(Targets$FileName[i],".bam", sep=""))
      if(.Platform$OS.type=="windows"){
            Try(bowtieLoc <- paste(myinfo[which(myinfo[,1]== "bowtieDirLocation"),2],"/bowtie.exe -a --best -k 1 -q -v 1 -S", sep=""))
            Try(system(paste(bowtieLoc,refGenome,inputData, outputSam, sep=" ")))
            Try(system(paste(picardLoc, " I=",outputSam, " O=", sub("sam$","bam", outputSam), sep="")))
            Try(file.remove(outputSam)) 
          # bowtie.exe -a -m 1 -q -v 1 -S chr1 tmp.fq tmp.out.sam
     } else if(.Platform$OS.type!="windows"){
            Try(bowtieLoc <- paste(myinfo[which(myinfo[,1]== "bowtieDirLocation"),2],"/bowtie -a --best -k 1 -q -v 1 -S", sep=""))
            Try(system(paste(bowtieLoc,refGenome,inputData, outputSam, sep=" ")))
            Try(system(paste(picardLoc, " I=",outputSam, " O=", sub("sam$","bam", outputSam), sep=""))) 
            Try(file.remove(outputSam))
     }
   }
     Try(newfilename <- paste("target", gsub(" ", "_",date()),"_sam.txt",sep=""))
     Try(newfilename <- gsub("\\:", "-",newfilename))
     
     Try(write.table(Targets.sam, newfilename, row.names=F, quote = F, sep="\t"))
     Try(tkmessageBox(title="Bowtie primary mapping",message=paste("Bowtie primary mapping is finished.\nBAM files are available in",getwd(),"The target file to load bam files in oneChannelGUI is",newfilename, sep="\n"),type="ok"))
     Try(usedtime <- proc.time() - ptm)
     Try(cat("\nUsed CPU time (min) ",usedtime[3]/60,"\n"))
     Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
     Try(tkfocus(.affylmGUIglobals$ttMain))

}
################################################################################
"NGSreformat" <- function(){
  Try(tkfocus(.affylmGUIglobals$ttMain))
  Try(ptm <- proc.time())
  Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
  Try(perlDirLocation <- get("perlDirLocation",envir=affylmGUIenvironment))
  Try(perl.info <- "")
  Try(perl.info <- system("perl -v", intern=T))
  
  if(length(grep("perl", perl.info)) == 0){
      Try(tkmessageBox(title="Perl program",message="Perl program is not installed!",type="ok", icon="error"))
      Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
      Try(return())
  }
  #load target
  Try(ttExonandTargets<-tktoplevel(.affylmGUIglobals$ttMain))
	Try(tkwm.deiconify(ttExonandTargets))
	Try(tkgrab.set(ttExonandTargets))
	Try(tkfocus(ttExonandTargets))
	Try(tkwm.title(ttExonandTargets,"Targets file"))
	Try(tkgrid(tklabel(ttExonandTargets,text="    ")))

	OpenTargetsFileAndSetCursor <- function()
	{
			Try(tkconfigure(ttExonandTargets,cursor="watch"))
			Try(tkfocus(ttExonandTargets))
			Try(OpenTargetsFile())
			Try(tkconfigure(ttExonandTargets,cursor="arrow"))
			Try(tkfocus(ttExonandTargets))
	}

	Try(OpenTargetsFile.but <- tkbutton(ttExonandTargets, text="Select Targets File",command=OpenTargetsFile,font=.affylmGUIglobals$affylmGUIfont2))

	Try(tclvalue(.affylmGUIglobals$TargetsfileName) <- fixSeps(tclvalue(.affylmGUIglobals$TargetsfileName)))
	Try(TargetsfileBoxTitleLabel <- tklabel(ttExonandTargets,text=as.character(tclvalue(.affylmGUIglobals$TargetsfileBoxTitle)),font=.affylmGUIglobals$affylmGUIfont2))
	Try(TargetsfileNameLabel <- tklabel(ttExonandTargets,text=as.character(tclvalue(.affylmGUIglobals$TargetsfileName)),background="white",font=.affylmGUIglobals$affylmGUIfont2))
	Try(tkconfigure(TargetsfileBoxTitleLabel, textvariable=.affylmGUIglobals$TargetsfileBoxTitle))
	Try(tkconfigure(TargetsfileNameLabel, textvariable=.affylmGUIglobals$TargetsfileName))

	Try(tkgrid(tklabel(ttExonandTargets,text="    ")))
	Try(tkgrid(TargetsfileBoxTitleLabel,columnspan=4))
	Try(tkgrid(TargetsfileNameLabel,columnspan=4))

	Try(tkgrid(tklabel(ttExonandTargets,text="    ")))

	Try(tkgrid(tklabel(ttExonandTargets,text="    "),OpenTargetsFile.but))
	Try(tkgrid.configure(OpenTargetsFile.but,columnspan=2))
	Try(Abort <- 1)
	onOK <- function()
	{
			Try(Targets <- get("Targets",envir=affylmGUIenvironment))
			Try(if(length(Targets)==0)
			{
				Try(tkmessageBox(title="NGS Targets File",message=paste("Either you did not specify a valid NGS Targets File",
					"or an error occurred while reading in the Targets file.	It should be in tab-delimited text format and it should include the column headings \"FileName\", and \"Target\".",icon="error")))
				onCancel()
#				return()
			})
			Try(tkgrab.release(ttExonandTargets));
			Try(tkdestroy(ttExonandTargets));
			Try(tkfocus(.affylmGUIglobals$ttMain))
			Try(Abort <<- 0)
	}
	onCancel <- function() {Try(tkgrab.release(ttExonandTargets));Try(tkdestroy(ttExonandTargets));Try(tkfocus(.affylmGUIglobals$ttMain));Try(Abort<<-1)}
	Try(OK.but <-tkbutton(ttExonandTargets,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
	Try(Cancel.but <-tkbutton(ttExonandTargets,text=" Cancel ",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))
	Try(tkgrid(tklabel(ttExonandTargets,text="    ")))
	Try(tkgrid(tklabel(ttExonandTargets,text="    "),OK.but,Cancel.but))
	Try(tkgrid(tklabel(ttExonandTargets,text="       ")))
	Try(tkfocus(ttExonandTargets))
	Try(tkbind(ttExonandTargets, "<Destroy>", function() {Try(tkgrab.release(ttExonandTargets));Try(tkfocus(.affylmGUIglobals$ttMain));}))
	Try(tkwait.window(ttExonandTargets))

	if(Abort==1)
				return(0)
  
	Try(Targets <- get("Targets",affylmGUIenvironment))
	Try(slides <- Targets$FileName)
	
  Try(Targets <- get("Targets",envir=affylmGUIenvironment))
  Try(rownames(Targets) <- Targets$FileName) 
  Try(var.tmp.pd<-data.frame(names(Targets)))
  Try(names(var.tmp.pd)<-"labelDescription" )
  Try(rownames(var.tmp.pd)<-names(Targets))
  Try(tmp1.pd<-new("AnnotatedDataFrame", data=Targets, varMetadata=var.tmp.pd))
  Try(target.array.names <- sub(".CEL", "", tmp1.pd$FileName))
  Try(target.array.names <- paste(tmp1.pd$FileName, ".bed", sep=""))   #giving the extension filename of counts data produced reformatting the output of shrimp
  #NGS reads number and reformatting Tartget in Targets #######################
  Try(tmpTarget <- Targets$Target)
  Try(tmpTarget <- strsplit(tmpTarget, "_"))
  Try(newTarget <- sapply(tmpTarget, function(x)x[1]))
  Try(Targets$Target <- newTarget)
  Try(rownames(Targets) <- NULL)
  Try(assign("Targets",Targets,envir=affylmGUIenvironment))
  Try(totalReads <- sapply(tmpTarget, function(x)x[2]))
  Try(mappedReads <- sapply(tmpTarget, function(x)x[3]))
  Try(assign("totalReads", as.numeric(totalReads),envir=affylmGUIenvironment))
  Try(assign("mappedReads", as.numeric(mappedReads),envir=affylmGUIenvironment))
  
   ###########     
   Try(Targets <- get("Targets",envir=affylmGUIenvironment))
   #defining the the type of input of mapped NGS data
   Try(ttGetNGSinput <- tktoplevel(.affylmGUIglobals$ttMain))
   Try(tkwm.deiconify(ttGetNGSinput))
   Try(tkgrab.set(ttGetNGSinput))
   Try(tkfocus(ttGetNGSinput))
   Try(tkwm.title(ttGetNGSinput,"Selecting Type of NGS input data"))
   #
   Try(tkgrid(tklabel(ttGetNGSinput,text="    ")))
   Try(NGSinputTcl <- tclVar("SHRIMP"))
   Try(rbA <- tkradiobutton(ttGetNGSinput,text="SHRIMP output",variable=NGSinputTcl,value="SHRIMP",font=.affylmGUIglobals$affylmGUIfont2))
   Try(rbB <- tkradiobutton(ttGetNGSinput,text="mature miRNAs from miRanalyser",variable=NGSinputTcl,value="miRanalyser",font=.affylmGUIglobals$affylmGUIfont2))
	 Try(rbC <- tkradiobutton(ttGetNGSinput,text="mature miRNAs from MicroRazerS",variable=NGSinputTcl,value="MicroRazerS",font=.affylmGUIglobals$affylmGUIfont2))
        
   Try(tkgrid(tklabel(ttGetNGSinput,text="    "),rbA))
   Try(tkgrid(tklabel(ttGetNGSinput,text="    "),rbB))
   Try(tkgrid(tklabel(ttGetNGSinput,text="    "),rbC))
      
 	 Try(tkgrid.configure(rbA,rbB, rbC, columnspan=2,sticky="w"))
 	 Try(tkgrid(tklabel(ttGetNGSinput,text="    "),tklabel(ttGetNGSinput,text="    ")))
	 #
	 Try(ReturnNGSinput <- "")
	 Try(
		         onCancel <- function() {
			          Try(ReturnNGSinput <<- "");
			          Try(tkgrab.release(ttGetNGSinput));
			          Try(tkdestroy(ttGetNGSinput));
			          Try(tkfocus(.affylmGUIglobals$ttMain))
		        }
	 )
	 Try(
		       onOK <- function() {
			         Try(ReturnNGSinput <<- tclvalue(NGSinputTcl));
			         Try(tkgrab.release(ttGetNGSinput));
			         Try(tkdestroy(ttGetNGSinput));
			         Try(tkfocus(.affylmGUIglobals$ttMain))
		      }
	 )
   #
	 Try(OK.but     <- tkbutton(ttGetNGSinput,text="OK",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
	 Try(Cancel.but <- tkbutton(ttGetNGSinput,text="Cancel",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))
	 #
	 Try(tkgrid(tklabel(ttGetNGSinput,text="    "),OK.but,Cancel.but,tklabel(ttGetNGSinput,text="    ")))
	 Try(tkgrid.configure(OK.but,sticky="e"))
	 Try(tkgrid.configure(Cancel.but,sticky="w"))
	 Try(tkgrid(tklabel(ttGetNGSinput,text="    ")))
	 #
	 Try(tkbind(ttGetNGSinput,"<Destroy>",function() {ReturnNGSinput <- "";Try(tkgrab.release(ttGetNGSinput));Try(tkfocus(.affylmGUIglobals$ttMain));}))
	 Try(tkbind(OK.but, "<Return>",onOK))
	 Try(tkbind(Cancel.but, "<Return>",onCancel))
	 #
	 Try(tkwait.window(ttGetNGSinput))
   if(ReturnNGSinput == "SHRIMP"){
       #which organism
       Try(ttGetOrganism <- tktoplevel(.affylmGUIglobals$ttMain))
	     Try(tkwm.deiconify(ttGetOrganism))
       Try(tkgrab.set(ttGetOrganism))
       Try(tkfocus(ttGetOrganism))
       Try(tkwm.title(ttGetOrganism,"Which organism"))
	
 	     Try(tkgrid(tklabel(ttGetOrganism,text="    ")))
       Try(ttGetOrganismTcl <- tclVar("hs"))
       Try(rbIQR.5 <- tkradiobutton(ttGetOrganism,text="H. sapiens",variable=ttGetOrganismTcl,value="hs",font=.affylmGUIglobals$affylmGUIfont2))
       Try(rbIQR.25<-tkradiobutton(ttGetOrganism,text="M. musculus",variable=ttGetOrganismTcl,value="mm",font=.affylmGUIglobals$affylmGUIfont2))
       Try(rbIQR.50<-tkradiobutton(ttGetOrganism,text="oneChannelGUI miRbase precursors",variable=ttGetOrganismTcl,value="mirbase",font=.affylmGUIglobals$affylmGUIfont2))
       Try(tkgrid(tklabel(ttGetOrganism,text="    "),rbIQR.5))
	     Try(tkgrid(tklabel(ttGetOrganism,text="    "),rbIQR.25))
	     Try(tkgrid(tklabel(ttGetOrganism,text="    "),rbIQR.50))

	     Try(tkgrid.configure(rbIQR.5,rbIQR.25, rbIQR.50,columnspan=2,sticky="w"))
	     Try(tkgrid(tklabel(ttGetOrganism,text="    "),tklabel(ttGetOrganism,text="    ")))
       Try(ReturnVal <- "")
       Try(onCancel <- function() {Try(ReturnVal <<- "");Try(tkgrab.release(ttGetOrganism));Try(tkdestroy(ttGetOrganism));Try(tkfocus(.affylmGUIglobals$ttMain))})
       Try(onOK <- function() {Try(ReturnVal <<- tclvalue(ttGetOrganismTcl));Try(tkgrab.release(ttGetOrganism));Try(tkdestroy(ttGetOrganism));Try(tkfocus(.affylmGUIglobals$ttMain))})
       Try(OK.but     <- tkbutton(ttGetOrganism,text="OK",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
       Try(Cancel.but <- tkbutton(ttGetOrganism,text="Cancel",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))

	     Try(tkgrid(tklabel(ttGetOrganism,text="    "),OK.but,Cancel.but, tklabel(ttGetOrganism,text="    ")))
       Try(tkgrid.configure(OK.but,sticky="e"))
	     Try(tkgrid.configure(Cancel.but,sticky="w"))
	     Try(tkgrid(tklabel(ttGetOrganism,text="    ")))

       Try(tkbind(ttGetOrganism,"<Destroy>",function() {ReturnVal <- "";Try(tkgrab.release(ttGetOrganism));Try(tkfocus(.affylmGUIglobals$ttMain));}))
       Try(tkbind(OK.but, "<Return>",onOK))
       Try(tkbind(Cancel.but, "<Return>",onCancel))      
       Try(tkwait.window(ttGetOrganism))
       Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
  
       if(ReturnVal == ""){
            Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
            Try(return())
       } else if (ReturnVal == "hs"){
             Try(cat("Be patient!!!!.....\n"))
             Try(cat("reformatting data aligned using H. sapiens as reference\n"))
             for(i in Targets$FileName){
                Try(cat("Processing ", i,"\n"))
                Try(system(paste("perl", paste(perlDirLocation, "/shrimpENSEMBL2genominator.hs.pl", sep=""), i, sep=" ")))
            }
       } else if (ReturnVal == "mm"){
             Try(cat("Be patient!!!!.....\n"))
             Try(cat("reformatting data aligned using M. musculus as reference genome\n"))
             for(i in Targets$FileName){
                Try(cat("Processing ", i,"\n"))
                Try(system(paste("perl", paste(perlDirLocation, "/shrimpENSEMBL2genominator.mm.pl", sep=""), i, sep=" ")))
            }
       } else if (ReturnVal == "mirbase"){
             Try(cat("Be patient!!!!.....\n"))
             Try(cat("reformatting data aligned using the miRbase precursors, generated using oneChannelGUI \nExport miRbase fasta reference file for microRNA-seq quantitative analysis function,\nas reference\n"))
             for(i in Targets$FileName){
                Try(cat("Processing ", i,"\n"))
                Try(system(paste("perl", paste(perlDirLocation, "/shrimpENSEMBL2genominator.mirbase.pl", sep=""), i, sep=" ")))
            }
       } 
    } else if(ReturnNGSinput == "MicroRazerS"){
       #which organism
       Try(ttGetOrganism <- tktoplevel(.affylmGUIglobals$ttMain))
	     Try(tkwm.deiconify(ttGetOrganism))
       Try(tkgrab.set(ttGetOrganism))
       Try(tkfocus(ttGetOrganism))
       Try(tkwm.title(ttGetOrganism,"Which organism"))
	
 	     Try(tkgrid(tklabel(ttGetOrganism,text="    ")))
       Try(ttGetOrganismTcl <- tclVar("hs"))
       Try(rbIQR.5 <- tkradiobutton(ttGetOrganism,text="H. sapiens",variable=ttGetOrganismTcl,value="hs",font=.affylmGUIglobals$affylmGUIfont2))
       Try(tkgrid(tklabel(ttGetOrganism,text="    "),rbIQR.5))

	     Try(tkgrid.configure(rbIQR.5, columnspan=2,sticky="w"))
	     Try(tkgrid(tklabel(ttGetOrganism,text="    "),tklabel(ttGetOrganism,text="    ")))
       Try(ReturnVal <- "")
       Try(onCancel <- function() {Try(ReturnVal <<- "");Try(tkgrab.release(ttGetOrganism));Try(tkdestroy(ttGetOrganism));Try(tkfocus(.affylmGUIglobals$ttMain))})
       Try(onOK <- function() {Try(ReturnVal <<- tclvalue(ttGetOrganismTcl));Try(tkgrab.release(ttGetOrganism));Try(tkdestroy(ttGetOrganism));Try(tkfocus(.affylmGUIglobals$ttMain))})
       Try(OK.but     <- tkbutton(ttGetOrganism,text="OK",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
       Try(Cancel.but <- tkbutton(ttGetOrganism,text="Cancel",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))

	     Try(tkgrid(tklabel(ttGetOrganism,text="    "),OK.but,Cancel.but, tklabel(ttGetOrganism,text="    ")))
       Try(tkgrid.configure(OK.but,sticky="e"))
	     Try(tkgrid.configure(Cancel.but,sticky="w"))
	     Try(tkgrid(tklabel(ttGetOrganism,text="    ")))

       Try(tkbind(ttGetOrganism,"<Destroy>",function() {ReturnVal <- "";Try(tkgrab.release(ttGetOrganism));Try(tkfocus(.affylmGUIglobals$ttMain));}))
       Try(tkbind(OK.but, "<Return>",onOK))
       Try(tkbind(Cancel.but, "<Return>",onCancel))      
       Try(tkwait.window(ttGetOrganism))
       Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
  
       if(ReturnVal == ""){
            Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
             Try(tkfocus(.affylmGUIglobals$ttMain))
            Try(return())
       } else if (ReturnVal == "hs"){
             Try(cat("Be patient!!!!.....\n"))
             Try(cat("reformatting data aligned using H. sapiens as reference genome\n"))
             for(i in Targets$FileName){
                Try(cat("Processing ", i,"\n"))
                Try(system(paste("perl", paste(perlDirLocation, "/MicroRazerSENSEMBL2genominator.hs.pl", sep=""), i, sep=" ")))
            }
       }
    } else if(ReturnNGSinput == "miRanalyser"){
              Try(tkmessageBox(title="NGS data reformatting",message="Tab delimited files for mature miRNAs produced by miRanalyser can be directly loaded on oneChannelGUI without reformatting."))
    }
    Try(usedtime <- proc.time() - ptm)
    Try(cat("\nUsed CPU time (min) ",usedtime[3]/60,"\n"))
    Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
     Try(tkfocus(.affylmGUIglobals$ttMain))
}
################################################################################
"adaptorTrimm" <-function(){
  Try(tkfocus(.affylmGUIglobals$ttMain))
  Try(SetWD())
  Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
  Try(perlDirLocation <- get("perlDirLocation",envir=affylmGUIenvironment))
  Try(perl.info <- "")
  Try(perl.info <- system("perl -v", intern=T))
  
  if(length(grep("perl", perl.info)) == 0){
      Try(tkmessageBox(title="Perl program",message="Perl program is not installed!",type="ok", icon="error"))
      Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
      Try(return())
  }
  #load target
  Try(ttExonandTargets<-tktoplevel(.affylmGUIglobals$ttMain))
	Try(tkwm.deiconify(ttExonandTargets))
	Try(tkgrab.set(ttExonandTargets))
	Try(tkfocus(ttExonandTargets))
	Try(tkwm.title(ttExonandTargets,"Targets file"))
	Try(tkgrid(tklabel(ttExonandTargets,text="    ")))

	OpenTargetsFileAndSetCursor <- function()
	{
			Try(tkconfigure(ttExonandTargets,cursor="watch"))
			Try(tkfocus(ttExonandTargets))
			Try(OpenTargetsFile())
			Try(tkconfigure(ttExonandTargets,cursor="arrow"))
			Try(tkfocus(ttExonandTargets))
	}

	Try(OpenTargetsFile.but <- tkbutton(ttExonandTargets, text="Select Targets File",command=OpenTargetsFile,font=.affylmGUIglobals$affylmGUIfont2))

	Try(tclvalue(.affylmGUIglobals$TargetsfileName) <- fixSeps(tclvalue(.affylmGUIglobals$TargetsfileName)))
	Try(TargetsfileBoxTitleLabel <- tklabel(ttExonandTargets,text=as.character(tclvalue(.affylmGUIglobals$TargetsfileBoxTitle)),font=.affylmGUIglobals$affylmGUIfont2))
	Try(TargetsfileNameLabel <- tklabel(ttExonandTargets,text=as.character(tclvalue(.affylmGUIglobals$TargetsfileName)),background="white",font=.affylmGUIglobals$affylmGUIfont2))
	Try(tkconfigure(TargetsfileBoxTitleLabel, textvariable=.affylmGUIglobals$TargetsfileBoxTitle))
	Try(tkconfigure(TargetsfileNameLabel, textvariable=.affylmGUIglobals$TargetsfileName))

	Try(tkgrid(tklabel(ttExonandTargets,text="    ")))
	Try(tkgrid(TargetsfileBoxTitleLabel,columnspan=4))
	Try(tkgrid(TargetsfileNameLabel,columnspan=4))

	Try(tkgrid(tklabel(ttExonandTargets,text="    ")))

	Try(tkgrid(tklabel(ttExonandTargets,text="    "),OpenTargetsFile.but))
	Try(tkgrid.configure(OpenTargetsFile.but,columnspan=2))
	Try(Abort <- 1)
	onOK <- function()
	{
			Try(Targets <- get("Targets",envir=affylmGUIenvironment))
			Try(if(length(Targets)==0)
			{
				Try(tkmessageBox(title="NGS Targets File",message=paste("Either you did not specify a valid NGS Targets File",
					"or an error occurred while reading in the Targets file.	It should be in tab-delimited text format and it should include the column headings \"FileName\", and \"Target\".",icon="error")))
				onCancel()
#				return()
			})
			Try(tkgrab.release(ttExonandTargets));
			Try(tkdestroy(ttExonandTargets));
			Try(tkfocus(.affylmGUIglobals$ttMain))
			Try(Abort <<- 0)
	}
	onCancel <- function() {Try(tkgrab.release(ttExonandTargets));Try(tkdestroy(ttExonandTargets));Try(tkfocus(.affylmGUIglobals$ttMain));Try(Abort<<-1)}
	Try(OK.but <-tkbutton(ttExonandTargets,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
	Try(Cancel.but <-tkbutton(ttExonandTargets,text=" Cancel ",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))
	Try(tkgrid(tklabel(ttExonandTargets,text="    ")))
	Try(tkgrid(tklabel(ttExonandTargets,text="    "),OK.but,Cancel.but))
	Try(tkgrid(tklabel(ttExonandTargets,text="       ")))
	Try(tkfocus(ttExonandTargets))
	Try(tkbind(ttExonandTargets, "<Destroy>", function() {Try(tkgrab.release(ttExonandTargets));Try(tkfocus(.affylmGUIglobals$ttMain));}))
	Try(tkwait.window(ttExonandTargets))

	if(Abort==1)
				return(0)
  
	Try(Targets <- get("Targets",affylmGUIenvironment))
	Try(slides <- Targets$FileName)
	
  Try(Targets <- get("Targets",envir=affylmGUIenvironment))
  Try(rownames(Targets) <- Targets$FileName) 
  Try(var.tmp.pd<-data.frame(names(Targets)))
  Try(names(var.tmp.pd)<-"labelDescription" )
  Try(rownames(var.tmp.pd)<-names(Targets))
  Try(tmp1.pd<-new("AnnotatedDataFrame", data=Targets, varMetadata=var.tmp.pd))
  Try(target.array.names <- sub(".CEL", "", tmp1.pd$FileName))
  Try(target.array.names <- paste(tmp1.pd$FileName, ".bed", sep=""))   #giving the extension filename of counts data produced reformatting the output of shrimp
  #NGS reads number and reformatting Tartget in Targets #######################
  Try(tmpTarget <- Targets$Target)
  Try(tmpTarget <- strsplit(tmpTarget, "_"))
  Try(newTarget <- sapply(tmpTarget, function(x)x[1]))
  Try(Targets$Target <- newTarget)
  Try(rownames(Targets) <- NULL)
  Try(assign("Targets",Targets,envir=affylmGUIenvironment))
  Try(cat("Be patient!!!!.....\n"))
  Try(cat("Trimming 3,5 end linkers\n"))
  Try(tmp.file <- tempfile("trimming_stats", fileext=".pdf", tmpdir=getwd()))
  Try(tmp.file <- paste("trimming_stats", gsub(" ", "_",date()),".pdf",sep=""))
  Try(tmp.file <- gsub("\\:", "-",tmp.file))
  Try(pdf(tmp.file))
  for(i in Targets$FileName){
     Try(ptm <- proc.time())
     Try(file.copy(i, "tmp.fq"))
     Try(cat("Processing ", i,"\t"))
     #syntax in  Adapter_trim.pl
     Try(system(paste("perl", paste(perlDirLocation, "Adapter_trimCRA.pl -i ",paste(getwd(),"/",i, " -o ",sep=""), paste(getwd(),"/",i, "trim.fq ",sep=""), "-f 4 -q 1" , sep=""), sep=" ")))
     Try(mytime <- as.numeric(unlist(proc.time() - ptm)))
     Try(mytime <- mytime[3]/60)
     Try(cat(mytime," mins\n"))
     Try(tmp.hist <- read.table(paste(getwd(),"/",i, ".triml",sep=""), sep="\t", header=F, as.is=T))
     Try(par(mfrow=c(1,2)))
     Try(hist(tmp.hist[,1], main=paste("3' end trimming", i, sep="\n"), xlab="trimmed nts"))
     Try(hist(tmp.hist[,2], main=paste("5' end trimming", i, sep="\n"), xlab="trimmed nts"))
  }
  Try(dev.off())
  Try(tmp.trimmed <- paste(Targets$FileName, "trim.fq", sep=""))
  Try(Targets$FileName <- tmp.trimmed)
  Try(target.trimmed <- strsplit(tmp.file, "trimming_stats"))
  Try(trimming.stats <- paste("trimming_stats", as.character(unlist(target.trimmed))[2], sep="")) 
  Try(target.trimmed <- paste("target", as.character(unlist(target.trimmed))[2], sep=""))
  Try(target.trimmed <- sub(".pdf", ".txt", target.trimmed))
  Try(write.table(Targets,  target.trimmed, sep="\t", quote=FALSE, row.names=FALSE))
  Try(tkmessageBox(title="Trimming Statistics",message=paste("Trimming statistics are saved in",trimming.stats, "\nThe target file for Bowtie mapping is ", target.trimmed),type="ok", icon="info"))
  Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
  Try(tkfocus(.affylmGUIglobals$ttMain))
}
################################################################################
"mRNAbowtieRun" <-function(){
      Try(ptm <- proc.time())
      Try(tkfocus(.affylmGUIglobals$ttMain))
      Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
     #select ref genome 
     Try(ttGetGenomes <- tktoplevel(.affylmGUIglobals$ttMain))
     Try(tkwm.deiconify(ttGetGenomes))
     Try(tkgrab.set(ttGetGenomes))
     Try(tkfocus(ttGetGenomes))
     Try(tkwm.title(ttGetGenomes,"Which genome do you want to use as reference?"))
     Try(tkgrid(tklabel(ttGetGenomes,text="    ")))
     Try(ttGetGenomesTcl <- tclVar("hg19"))
     Try(rbIQR.hs <- tkradiobutton(ttGetGenomes,text="Human hg19 genome       ",variable=ttGetGenomesTcl,value="hg19",font=.affylmGUIglobals$affylmGUIfont2))
     Try(rbIQR.mm<-tkradiobutton(ttGetGenomes,text="Mouse mm9 genome          ",variable=ttGetGenomesTcl,value="mm9",font=.affylmGUIglobals$affylmGUIfont2))
     Try(rbIQR.rn<-tkradiobutton(ttGetGenomes,text="Rat rn4 genome            ",variable=ttGetGenomesTcl,value="rn4",font=.affylmGUIglobals$affylmGUIfont2))
     
     Try(tkgrid(tklabel(ttGetGenomes,text="    "),rbIQR.hs))
     Try(tkgrid(tklabel(ttGetGenomes,text="    "),rbIQR.mm))
     Try(tkgrid(tklabel(ttGetGenomes,text="    "),rbIQR.rn))

     Try(tkgrid.configure(rbIQR.hs,rbIQR.mm,rbIQR.rn, columnspan=2,sticky="w"))
     Try(tkgrid(tklabel(ttGetGenomes,text="    "),tklabel(ttGetGenomes,text="    ")))
     Try(ReturnVal1 <- "")
     Try(onCancel <- function() {Try(ReturnVal1 <<- "");Try(tkgrab.release(ttGetGenomes));Try(tkdestroy(ttGetGenomes));Try(tkfocus(.affylmGUIglobals$ttMain))})
     Try(onOK <- function() {Try(ReturnVal1 <<- tclvalue(ttGetGenomesTcl));Try(tkgrab.release(ttGetGenomes));Try(tkdestroy(ttGetGenomes));Try(tkfocus(.affylmGUIglobals$ttMain))})
     Try(OK.but     <- tkbutton(ttGetGenomes,text="OK",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
     Try(Cancel.but <- tkbutton(ttGetGenomes,text="Cancel",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))

     Try(tkgrid(tklabel(ttGetGenomes,text="    "),OK.but,Cancel.but, tklabel(ttGetGenomes,text="    ")))
     Try(tkgrid.configure(OK.but,sticky="e"))
     Try(tkgrid.configure(Cancel.but,sticky="w"))
     Try(tkgrid(tklabel(ttGetGenomes,text="    ")))

     Try(tkbind(ttGetGenomes,"<Destroy>",function() {ReturnVal1 <- "";Try(tkgrab.release(ttGetGenomes));Try(tkfocus(.affylmGUIglobals$ttMain));}))
     Try(tkbind(OK.but, "<Return>",onOK))
     Try(tkbind(Cancel.but, "<Return>",onCancel))      
     Try(tkwait.window(ttGetGenomes))
     Try(cat("\nBe patient! mapping will take a while...\n"))
     Try(bowtieRefs <- get("bowtieRefs",envir=affylmGUIenvironment))
     Try(installed <- bowtieRefs[which(names(bowtieRefs)==ReturnVal1)]) #checking ofr the presence of the buld ref
     if(is.na(installed)){
         Try(cat(paste("\nMissing ", ReturnVal1, " reference genome! Please use the function:\nDownload and build hs, mm, rn bowtie reference sets\nto install it.", sep="")))
         Try(return())
     }else{
            if(names(installed)=="hg19"){
               Try(refG <- "hs_chr")
            }else if(names(installed)=="mm9"){
               Try(refG <- "mm_chr")
            }else if(names(installed)=="rn4"){
               Try(refG <- "rn_chr")
            }
     }
      Try(etcDir  <- paste(.path.package("oneChannelGUI", quiet = FALSE), "/etc", sep=""))
      Try(localdata <- paste(etcDir, "/localData.txt", sep=""))
      Try(myinfo <- read.table(localdata, sep="\t", header=F, as.is=T))
  #    Try(SetWD())
      Try(myWD <- getwd())
      if(is.na(myinfo[which(myinfo[,1]== "bowtieDirLocation"),2])){
           Try(tkmessageBox(title="Bowtie",message="Bowtie cannot be found please go to the General tool menu and use the function\nInstall Bowtie and Picard tools\nto install Bowtie.",icon="error",type="ok"))
           Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
           Try(tkfocus(.affylmGUIglobals$ttMain))
           Try(return())
      }
      Try(setwd(myinfo[which(myinfo[,1]== "bowtieDirLocation"),2]))
      
      Try(data.in.dir <- dir())
      Try(data.in.dir <- data.in.dir[grep('.ebwt$',data.in.dir)])
      Try(myrefid <- paste('^', refG,sep=""))
      Try(data.in.dir <- data.in.dir[grep(myrefid,data.in.dir)])
      Try(data.in.dir <- strsplit(data.in.dir, "\\."))
      Try(data.in.dir <- unique(sapply(data.in.dir, function(x) x[1])))
      Try(refnames <- paste(paste(data.in.dir[1:trunc(length(data.in.dir)/2)], seq(1, trunc(length(data.in.dir)/2)), sep=" = ", collapse=", "), paste(data.in.dir[(trunc(length(data.in.dir)/2)+1):length(data.in.dir)], seq((trunc(length(data.in.dir)/2)+1), length(data.in.dir)), sep=" = ", collapse=", "),sep="\n"))
      ##selecting the ref set for mapping  I.E. selecting the chromosome for the mapping
      Try(ttcolExtract<-tktoplevel(.affylmGUIglobals$ttMain))
      Try(tkwm.deiconify(ttcolExtract))
      Try(tkgrab.set(ttcolExtract))
      Try(tkfocus(ttcolExtract))
      Try(tkwm.title(ttcolExtract,"Defining the reference set to be used for bowtie mapping"))
      Try(tkgrid(tklabel(ttcolExtract,text="    ")))
      Try(refBowtie <- "")
      Try(Local.colExtract <- tclVar(init=refBowtie))
      Try(entry.colExtract <-tkentry(ttcolExtract,width="4",font=.affylmGUIglobals$affylmGUIfont2,textvariable=Local.colExtract,bg="white"))
      Try(tkgrid(tklabel(ttcolExtract,text=paste("Please enter the number associated to the reference set of interest\n", refnames),font=.affylmGUIglobals$affylmGUIfont2)))
      Try(tkgrid(entry.colExtract))
      onOK <- function()
      {
                     Try(assign("refBowtie", as.numeric(tclvalue(Local.colExtract)),affylmGUIenvironment))
                     Try(tkgrab.release(ttcolExtract));Try(tkdestroy(ttcolExtract));Try(tkfocus(.affylmGUIglobals$ttMain))                        
      }
      Try(OK.but <-tkbutton(ttcolExtract,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
      Try(tkgrid(tklabel(ttcolExtract,text="    ")))
      Try(tkgrid(OK.but))
      Try(tkgrid.configure(OK.but))
      Try(tkgrid(tklabel(ttcolExtract,text="       ")))
      Try(tkfocus(entry.colExtract))
      Try(tkbind(entry.colExtract, "<Return>",onOK))
      Try(tkbind(ttcolExtract, "<Destroy>", function(){Try(tkgrab.release(ttcolExtract));Try(tkfocus(.affylmGUIglobals$ttMain));return(0)}))
      Try(tkwait.window(ttcolExtract))
      Try(tkfocus(.affylmGUIglobals$ttMain))
      Try(refBowtie <- get("refBowtie", affylmGUIenvironment))
      if(is.na(refBowtie)){
                         Try(tkmessageBox(title="Defining the reference set to be used for bowtie mapping",message="You have not selected any reference set!\nIf you are interested to other references sequences other than miRNA precursors, you need to download them with the function:\nDownload bowtie built reference sets\navailable in General tools menu."))
                         Try(tkfocus(.affylmGUIglobals$ttMain))
                         Try(return())
      } else if(refBowtie > length(data.in.dir)){
                         Try(tkmessageBox(title="Defining the reference set to be used for bowtie mapping",message="You have selected a non existing reference set!"))
                         Try(tkfocus(.affylmGUIglobals$ttMain))
                         Try(return())
      }
      Try(tkmessageBox(title="Defining the reference set to be used for bowtie mapping",message=paste("You have selected", data.in.dir[refBowtie],"as reference set for bowtie mapping.", sep=" ")))
      Try(tkfocus(.affylmGUIglobals$ttMain))
      Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
      Try(setwd(myWD))  #back again in the working dir
      #defining bowtie params#####################################################
      Try(botwieParams<-tktoplevel(.affylmGUIglobals$ttMain))
      Try(tkwm.deiconify(botwieParams))
      Try(tkgrab.set(botwieParams))
      Try(tkfocus(botwieParams))
      Try(tkwm.title(botwieParams,"Bowtie parameters"))
      Try(tkgrid(tklabel(botwieParams,text="    ")))

      Try(frame1 <- tkframe(botwieParams,relief="groove",borderwidth=2))
      Try(HowManyQuestion1 <- tklabel(frame1,text="Number of allowed mismatches",font=.affylmGUIglobals$affylmGUIfont2))
      Try(tkgrid(HowManyQuestion1))
      Try(tkgrid.configure(HowManyQuestion1,columnspan=2,sticky="w"))
      Try(thresholdTcl <- tclVar("1"))
      Try(I0.but  <- tkradiobutton(frame1,text="1",variable=thresholdTcl,value="1",font=.affylmGUIglobals$affylmGUIfont2))
      Try(I1.but  <- tkradiobutton(frame1,text="2",variable=thresholdTcl,value="2",font=.affylmGUIglobals$affylmGUIfont2))
      Try(I2.but  <- tkradiobutton(frame1,text="3",variable=thresholdTcl,value="3",font=.affylmGUIglobals$affylmGUIfont2))
      Try(tkgrid(I0.but,sticky="w"))
      Try(tkgrid(I1.but,sticky="w"))
      Try(tkgrid(I2.but,sticky="w"))

      Try(tkgrid.configure(HowManyQuestion1,I0.but,I1.but,I2.but,sticky="w"))

      Try(frame2 <- tkframe(botwieParams,relief="groove",borderwidth=2))
      Try(fractionLabel <- tklabel(frame2,text="Input data type",font=.affylmGUIglobals$affylmGUIfont2))
      Try(tkgrid(fractionLabel,sticky="w"))
      Try(tkgrid.configure(fractionLabel,sticky="w"))
      Try(fractionTcl <- tclVar("pe"))
      Try(F1.but <- tkradiobutton(frame2,text="Pair-end",variable=fractionTcl,value="pe",font=.affylmGUIglobals$affylmGUIfont2))
      Try(F2.but <- tkradiobutton(frame2,text="single-end",variable=fractionTcl,value="se",font=.affylmGUIglobals$affylmGUIfont2))

      Try(tkgrid(F1.but, F2.but,sticky="w"))
      Try(tkgrid.configure(fractionLabel,F1.but,F2.but,sticky="w"))

      Try(onOK <- function()
      {
                            bowtieVal1 <- tclvalue(thresholdTcl)
                            bowtieVal2 <- tclvalue(fractionTcl)
                            Try(bowtieVal <<- paste(bowtieVal1, bowtieVal2, sep=";"))
                            Try(tkgrab.release(botwieParams))
                            Try(tkdestroy(botwieParams))
                            Try(tkfocus(.affylmGUIglobals$ttMain))
      })

      Try(frame3 <- tkframe(botwieParams,borderwidth=2))
      Try(onCancel <- function() {Try(bowtieVal <<- ""); Try(tkgrab.release(botwieParams));Try(tkdestroy(botwieParams));Try(tkfocus(.affylmGUIglobals$ttMain))})
      Try(OK.but <-tkbutton(frame3,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
      Try(Cancel.but <-tkbutton(frame3,text=" Cancel ",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))

      Try(tkgrid(tklabel(frame3,text="    "),OK.but,Cancel.but,tklabel(frame3,text="    ")))

      Try(tkgrid(tklabel(botwieParams,text="    "),frame1,frame2,tklabel(botwieParams,text="  ")))
      Try(tkgrid(tklabel(botwieParams,text="    ")))
      Try(tkgrid(tklabel(botwieParams,text="    "),frame3,tklabel(botwieParams,text="  ")))
      Try(tkgrid(tklabel(botwieParams,text="    ")))
      Try(tkgrid.configure(frame1,frame3,sticky="w"))

      Try(tkfocus(botwieParams))
      Try(tkbind(botwieParams, "<Destroy>", function() {Try(tkgrab.release(botwieParams));Try(tkfocus(.affylmGUIglobals$ttMain));}))
      Try(tkwait.window(botwieParams))
      Try(if(bowtieVal==""){return()} )
      Try(tmp <-strsplit(bowtieVal, ";"))
      Try(mismatch <- as.numeric(tmp[[1]][1]))
      Try(data.type <- tmp[[1]][2])
      ##########################################################################
     #default Thread 1
     Try(assign("Threads", 1 , affylmGUIenvironment)) 
     #defining number of threads
     if(.Platform$OS.type!="windows" ){
        Try(ttThreads<-tktoplevel(.affylmGUIglobals$ttMain))
	    Try(tkwm.deiconify(ttThreads))
	    Try(tkgrab.set(ttThreads))
	    Try(tkfocus(ttThreads))
	    Try(tkwm.title(ttThreads,"Defining the BG threshold for filtering"))
	    Try(tkgrid(tklabel(ttThreads,text="    ")))
	    Try(Threadsnum <- "1")
	    Try(Local.Threads <- tclVar(init=Threadsnum))
	    Try(entry.Threads <-tkentry(ttThreads,width="4",font=.affylmGUIglobals$affylmGUIfont2,textvariable=Local.Threads,bg="white"))
	    Try(tkgrid(tklabel(ttThreads,text="Please enter the number of cores to be used by Bowtie. \nIf you do not know what to do use 1.",font=.affylmGUIglobals$affylmGUIfont2)))
	    Try(tkgrid(entry.Threads))
	    onOK <- function()
	    {
	                     Try(Threadsnum <- trunc(as.numeric(tclvalue(Local.Threads))))
	                     Try(assign("Threads", trunc(as.numeric(tclvalue(Local.Threads))),affylmGUIenvironment))
				               Try(assign("Threads.available", TRUE,affylmGUIenvironment))
	                     Try(tkgrab.release(ttThreads));Try(tkdestroy(ttThreads));Try(tkfocus(.affylmGUIglobals$ttMain))                        
	    }
	    Try(OK.but <-tkbutton(ttThreads,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
	    Try(tkgrid(tklabel(ttThreads,text="    ")))
	    Try(tkgrid(OK.but))
	    Try(tkgrid.configure(OK.but))
	    Try(tkgrid(tklabel(ttThreads,text="       ")))
	    Try(tkfocus(entry.Threads))
	    Try(tkbind(entry.Threads, "<Return>",onOK))
	    Try(tkbind(ttThreads, "<Destroy>", function(){Try(tkgrab.release(ttThreads));Try(tkfocus(.affylmGUIglobals$ttMain));return(0)}))
	    Try(tkwait.window(ttThreads))
	    Try(tkfocus(.affylmGUIglobals$ttMain))
	  }
	  Try(Threadsnum <- get("Threads", env=affylmGUIenvironment))

    ############################################################################
      if(data.type == "pe"){
            Try(tkmessageBox(title="Pair-end mapping",message=paste("You have selected PAIR-END option.\nPlease remember that the two fastq files names, associated to the pair ends sequencing,\nhave to be written in the following format in the target file: filename1,filename2", sep=" ")))
      }
      #opening target for primary mapping
    	Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
      Try(ttExonandTargets<-tktoplevel(.affylmGUIglobals$ttMain))
	    Try(tkwm.deiconify(ttExonandTargets))
	    Try(tkgrab.set(ttExonandTargets))
	    Try(tkfocus(ttExonandTargets))
	    Try(tkwm.title(ttExonandTargets,"Targets file"))
      Try(tkgrid(tklabel(ttExonandTargets,text="    ")))

	    OpenTargetsFileAndSetCursor <- function()
	   {
		   	Try(tkconfigure(ttExonandTargets,cursor="watch"))
			  Try(tkfocus(ttExonandTargets))
			  Try(OpenTargetsFile())
			  Try(tkconfigure(ttExonandTargets,cursor="arrow"))
			  Try(tkfocus(ttExonandTargets))
	   } 

	   Try(OpenTargetsFile.but <- tkbutton(ttExonandTargets, text="Select Targets File",command=OpenTargetsFile,font=.affylmGUIglobals$affylmGUIfont2))

	   Try(tclvalue(.affylmGUIglobals$TargetsfileName) <- fixSeps(tclvalue(.affylmGUIglobals$TargetsfileName)))
	   Try(TargetsfileBoxTitleLabel <- tklabel(ttExonandTargets,text=as.character(tclvalue(.affylmGUIglobals$TargetsfileBoxTitle)),font=.affylmGUIglobals$affylmGUIfont2))
	   Try(TargetsfileNameLabel <- tklabel(ttExonandTargets,text=as.character(tclvalue(.affylmGUIglobals$TargetsfileName)),background="white",font=.affylmGUIglobals$affylmGUIfont2))
	   Try(tkconfigure(TargetsfileBoxTitleLabel, textvariable=.affylmGUIglobals$TargetsfileBoxTitle))
	   Try(tkconfigure(TargetsfileNameLabel, textvariable=.affylmGUIglobals$TargetsfileName))

	   Try(tkgrid(tklabel(ttExonandTargets,text="    ")))
	   Try(tkgrid(TargetsfileBoxTitleLabel,columnspan=4))
	   Try(tkgrid(TargetsfileNameLabel,columnspan=4))

	   Try(tkgrid(tklabel(ttExonandTargets,text="    ")))

	   Try(tkgrid(tklabel(ttExonandTargets,text="    "),OpenTargetsFile.but))
	   Try(tkgrid.configure(OpenTargetsFile.but,columnspan=2))
	   Try(Abort <- 1)
	   onOK <- function()
	  {
			  Try(Targets <- get("Targets",envir=affylmGUIenvironment))
			  Try(if(length(Targets)==0)
			  {
				   Try(tkmessageBox(title="NGS Targets File",message=paste("Either you did not specify a valid NGS Targets File",
					   "or an error occurred while reading in the Targets file.	It should be in tab-delimited text format and it should include the column headings \"FileName\", and \"Target\".",icon="error")))
				   onCancel()
			  })
			  Try(tkgrab.release(ttExonandTargets));
			  Try(tkdestroy(ttExonandTargets));
			  Try(tkfocus(.affylmGUIglobals$ttMain))
			  Try(Abort <<- 0)
	  }
	  onCancel <- function() {Try(tkgrab.release(ttExonandTargets));Try(tkdestroy(ttExonandTargets));Try(tkfocus(.affylmGUIglobals$ttMain));Try(Abort<<-1)}
	  Try(OK.but <-tkbutton(ttExonandTargets,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
	  Try(Cancel.but <-tkbutton(ttExonandTargets,text=" Cancel ",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))
	  Try(tkgrid(tklabel(ttExonandTargets,text="    ")))
	  Try(tkgrid(tklabel(ttExonandTargets,text="    "),OK.but,Cancel.but))
	  Try(tkgrid(tklabel(ttExonandTargets,text="       ")))
	  Try(tkfocus(ttExonandTargets))
	  Try(tkbind(ttExonandTargets, "<Destroy>", function() {Try(tkgrab.release(ttExonandTargets));Try(tkfocus(.affylmGUIglobals$ttMain));}))
	  Try(tkwait.window(ttExonandTargets))
      
	  if(Abort==1)
				return(0)
	  Try(tkfocus(.affylmGUIglobals$ttMain))
	  Try(Targets <- get("Targets",affylmGUIenvironment))
	  Try(Targets.sam <- Targets)
	  #make a bam file
    Try(javaDir <- get("javaDir",envir=affylmGUIenvironment))
    if(is.na(javaDir)){javaDir <- ""}
    if(javaDir != ""){
             Try(picardLoc <- paste('"',javaDir,'"',"/bin/java -jar ",myinfo[which(myinfo[,1]== "bowtieDirLocation"),2], "/SamFormatConverter.jar", sep=""))
    }else{
             Try(picardLoc <- paste("java -jar ",myinfo[which(myinfo[,1]== "bowtieDirLocation"),2], "/SamFormatConverter.jar", sep=""))
    }
#    Try(picardSort <- paste("java -jar ",myinfo[which(myinfo[,1]== "bowtieDirLocation"),2], "/SortSam.jar", sep=""))
#    Try(picardIndex <- paste("java -jar ",myinfo[which(myinfo[,1]== "bowtieDirLocation"),2], "/BuildBamIndex.jar", sep=""))
 
	  Try(refGenome <- paste(myinfo[which(myinfo[,1]== "bowtieDirLocation"),2],data.in.dir[refBowtie],sep="/"))
    Try(require(Rsamtools)||Stop("\nMissing Rsamtools library\n"))

    for (i in 1: dim(Targets)[1]){
      Try(cat("Processing: ", Targets$FileName[i],"\n"))
      if(data.type == "pe"){
              Try(pe.files <- as.character(unlist(strsplit(Targets$FileName[i], ","))))
              Try(sam.name <- paste(pe.files, collapse="-"))
              Try(mybam <- paste(data.in.dir[refBowtie],".bam", sep=""))
              Try(Targets.sam$FileName[i]<-paste(sam.name,mybam,sep="."))
      }else{
             Try(Targets.sam$FileName[i]<-paste(Targets$FileName[i],data.in.dir[refBowtie],".bam", sep=""))
      }
      if(.Platform$OS.type=="windows"){
            Try(bowtieLoc <- paste(myinfo[which(myinfo[,1]== "bowtieDirLocation"),2],"/bowtie.exe -a --best -k 1 -q -v ",mismatch," -S", sep=""))
            if(data.type == "pe"){
              Try(pe.files <- as.character(unlist(strsplit(Targets$FileName[i], ","))))
       	      Try(inputData1 <- paste(getwd(),pe.files[1],sep="/"))
       	      Try(inputData2 <- paste(getwd(),pe.files[2],sep="/"))
       	      Try(sam.name <- paste(pe.files, collapse="-"))
	      	  Try(outputSam <- paste(getwd(),paste(sam.name,".sam", sep=""),sep="/"))
              Try(system(paste(bowtieLoc,refGenome,"-1",inputData1,"-2",inputData2, outputSam, sep=" ")))
              Try(system(paste(picardLoc, " I=",outputSam, " O=tmp.bam", sep="")))
              Try(sortBam("tmp.bam","tmpS")) 
              Try(file.remove(outputSam))
              Try(file.remove("tmp.bam"))
              Try(indexBam("tmpS.bam"))
              Try(mybam <- sub("sam$",data.in.dir[refBowtie], outputSam))
              Try(filterBam("tmpS.bam", paste(mybam, ".bam", sep=""), index="tmpS.bam", indexDestination=TRUE, param=ScanBamParam(flag=scanBamFlag(isProperPair = TRUE, isUnmappedQuery = FALSE))))
              Try(file.remove("tmpS.bam"))
            }else{
	            Try(outputSam <- paste(getwd(),paste(Targets$FileName[i],".sam", sep=""),sep="/"))
       	      Try(inputData <- paste(getwd(),Targets$FileName[i],sep="/"))
              Try(system(paste(bowtieLoc,refGenome,inputData, outputSam, sep=" ")))
              Try(mybam <- sub("sam$",data.in.dir[refBowtie], outputSam))
              Try(system(paste(picardLoc, " I=",outputSam, " O=tmp.bam", sep="")))
              Try(sortBam("tmp.bam","tmpS")) 
              Try(file.remove(outputSam))
              Try(file.remove("tmp.bam"))
              Try(indexBam("tmpS.bam"))
              Try(mybam <- sub("sam$",data.in.dir[refBowtie], outputSam))
              Try(filterBam("tmpS.bam", paste(mybam, ".bam", sep=""), index="tmpS.bam", indexDestination=TRUE, param=ScanBamParam(flag=scanBamFlag(isProperPair = TRUE, isUnmappedQuery = FALSE))))
              Try(file.remove("tmpS.bam"))
           } 
          # bowtie.exe -a -m 1 -q -v 1 -S chr1 tmp.fq tmp.out.sam
     } else if(.Platform$OS.type!="windows"){
            Try(bowtieLoc <- paste(myinfo[which(myinfo[,1]== "bowtieDirLocation"),2],"/bowtie -p ",Threadsnum," -a --best -k 1 -q -v ",mismatch," -S", sep=""))
            if(data.type == "pe"){
              Try(pe.files <- as.character(unlist(strsplit(Targets$FileName[i], ","))))
       	      Try(inputData1 <- paste(getwd(),pe.files[1],sep="/"))
       	      Try(inputData2 <- paste(getwd(),pe.files[2],sep="/"))
       	      Try(sam.name <- paste(pe.files, collapse="-"))
	      	  Try(outputSam <- paste(getwd(),paste(sam.name,".sam", sep=""),sep="/"))
              Try(system(paste(bowtieLoc,refGenome,"-1",inputData1,"-2",inputData2, outputSam, sep=" ")))
              Try(system(paste(picardLoc, " I=",outputSam, " O=tmp.bam", sep="")))
              Try(sortBam("tmp.bam","tmpS")) 
              Try(file.remove(outputSam))
              Try(file.remove("tmp.bam"))
              Try(indexBam("tmpS.bam"))
              Try(mybam <- sub("sam$",data.in.dir[refBowtie], outputSam))
              Try(filterBam("tmpS.bam", paste(mybam, ".bam", sep=""), index="tmpS.bam", indexDestination=TRUE, param=ScanBamParam(flag=scanBamFlag(isProperPair = TRUE, isUnmappedQuery = FALSE))))
              Try(file.remove("tmpS.bam"))
            }else{
	            Try(outputSam <- paste(getwd(),paste(Targets$FileName[i],".sam", sep=""),sep="/"))
       	      Try(inputData <- paste(getwd(),Targets$FileName[i],sep="/"))
              Try(system(paste(bowtieLoc,refGenome,inputData, outputSam, sep=" ")))
              Try(system(paste(picardLoc, " I=",outputSam, " O=tmp.bam", sep="")))
              Try(sortBam("tmp.bam","tmpS")) 
              Try(file.remove(outputSam))
              Try(file.remove("tmp.bam"))
              Try(indexBam("tmpS.bam"))
              Try(mybam <- sub("sam$",data.in.dir[refBowtie], outputSam))
              Try(filterBam("tmpS.bam", paste(mybam, ".bam", sep=""), index="tmpS.bam", indexDestination=TRUE, param=ScanBamParam(flag=scanBamFlag(isProperPair = TRUE, isUnmappedQuery = FALSE))))
              Try(file.remove("tmpS.bam"))
            } 
     }
   }
     Try(newfilename <- paste("target", gsub(" ", "_",date()),"_sam.txt",sep=""))
     Try(newfilename <- gsub("\\:", "-",newfilename))
     
     Try(write.table(Targets.sam, newfilename, row.names=F, quote = F, sep="\t"))
     Try(tkmessageBox(title="Bowtie primary mapping",message=paste("Bowtie primary mapping is finished.\nBAM files are available in",getwd(),"The target file to load bam files in oneChannelGUI is",newfilename, sep="\n"),type="ok"))
     Try(usedtime <- proc.time() - ptm)
     Try(cat("\nUsed CPU time (min) ",usedtime[3]/60,"\n"))
     Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
     Try(tkfocus(.affylmGUIglobals$ttMain))
}
##############################################################################
