\name{cosieWrapper}
\alias{cosieWrapper}
\title{A wrapper to cosie, Corrected Splicing Indices for Exon arrays, that for any given set of new exon array experiments
corrects for the observed bias and improves the detection of alternative splicing}
\description{COSIE is a function that for a given set of exon arrays corrects for the observed bias and improves 
the detection of alternative splicing. It adjusts splicing indices for exons, especially for those that belong 
to differentially expressed genes. For this adjustment, COSIE uses parameters that are specific for each probeset 
which were trained from a large number of published exon arrays. The downside of this approach is that such parameters 
cannot be estimated for all probesets on the microarray. Based on our training set, COSIE corrects 95.1 percent 
of the probesets. Separate parameter files are provided for both the full and core sets, including all 
probesets that are linked to transcripts. We recommend the use of the core set that was also used in the cited study below. 
The full set is not as well characterized.}
\usage{
cosieWrapper()
}
\author{Gaidatzis et al. Nucleic Acids Research, 2009, 1}
\seealso{cosieHscore, cosieMmcore, cosieHsfull, cosieMmfull}
\keyword{ manip }
